package iteriere;

import java.util.Iterator;
import java.util.function.Consumer;

public interface Schleife<E> extends Iterator<E>{
	boolean test();
	void step();
	E get();
	default boolean hasNext() {
		return test();
	}

	default E next() {
		var r = get();
		step();
		return r;
	}

	default void run(Consumer<E> consume) {
		for (;test();step()) {
			var x = get();
			consume.accept(x);
		}
	}
}
